#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "signal.h"
#include <SDL/SDL.h>
#include <mikmod.h>
#include <math.h>


/*#define klkm 54
char dat[320*240*klkm];*/


typedef struct Blk {
  int xr, yr, tr;
  char *data;
  struct Blk *next;
} Blk;

typedef struct {
  int xcnt, ycnt, tcnt, tot;
  Blk *root;
  Blk **data;
} Movie;

#define dprintf (void)
//printf

Movie *readmovie(FILE *f) {
  int xr, yr, zr, cnt;
  unsigned char pakres;
  Movie *m=malloc(sizeof(Movie));
  Blk **nxt=&m->root;
  m->xcnt=320/16; m->ycnt=240/16; m->tcnt=32; m->tot=0;
  do {
    Blk *b;
    if (fread(&pakres, 1, 1, f)!=1) break;
    b=malloc(sizeof(Blk)); b->tr=pakres/36%7; b->yr=pakres/6%6; b->xr=pakres%6;
    dprintf("xr %i yr %i tr %i\n", b->xr, b->yr, b->tr);
    b->data=malloc(1<<b->xr+b->yr+b->tr);
    fread(b->data, 1, 1<<b->xr+b->yr+b->tr, f);
    b->next=0; 
    *nxt=b; nxt=&b->next;
    m->tot++;
  } while (1+1!=3);
  { 
    int i; 
    Blk *b=m->root;
    m->data=malloc(sizeof(Blk*)*m->tot);
    for (i=0; i<m->tot; i++) { if (!b) exit(1); m->data[i]=b, b=b->next; }
  }
  return m;
}

void drawblk(char *buf, int pitch, Blk *b, int xs, int ys, int fno) {
  char *kuv=b->data+(fno<<b->tr>>12<<b->xr+b->yr);
  int xsi=(256<<b->xr)/xs, ysi=(256<<b->yr)/ys, x, y;
//  if (b->xr!=4 || b->yr!=4 || b->tr!=4) exit(1);
  for (y=0; y<ys; y++) {
    for (x=0; x<xs; x++) *buf++=kuv[(y*ysi>>8<<b->xr)+(x*xsi>>8)];
    buf+=pitch-xs;
  }
}


void drawblk3(char *buf, int pitch, Blk *b, int xs, int ys, int fno) {
  char *kuv=b->data+(fno<<b->tr>>12<<b->xr+b->yr);
  int xsi=(256<<b->xr)/xs, ysi=(256<<b->yr)/ys, x, y;
//  if (b->xr!=4 || b->yr!=4 || b->tr!=4) exit(1);
  for (y=0; y<ys; y++) {
    for (x=0; x<xs; x++) *buf++=kuv[(y*ysi>>8<<b->xr)+(x*xsi>>8)];
    buf+=pitch-xs;
  }
}



void getframe(char *buf, int pitch, Movie *m, int xs, int ys, int fno) {
  Blk **b0=m->data+((fno>>12)%m->tcnt+m->tcnt)%m->tcnt*m->ycnt*m->xcnt;
  int xk=xs/m->xcnt, yk=ys/m->ycnt, x, y;
  for (y=0; y<m->ycnt; y++) for (x=0; x<m->xcnt; x++)
    drawblk(buf+y*yk*pitch+x*xk, pitch, b0[y*m->xcnt+x], xk, yk, fno&4095);
}

void drawblk2(char *buf, int pitch, Blk *b, int xs, int ys, int fno) {
  char *kuv=b->data+(fno<<b->tr>>12<<b->xr+b->yr);
  int xsi=xs>>b->xr, ysi=ys>>b->yr, x, y;
//  if (b->xr!=4 || b->yr!=4 || b->tr!=4) exit(1);
  for (y=0; y<1<<b->yr; y++) {
    for (x=0; x<1<<b->xr; x++) buf[(y*ysi)*pitch+(x*xsi)]=*kuv++;
  }
}


void tark(char *buf, int pitch, int xs, int ys, int x0, int y0, int xi, int yi, int delt) {
  int x, y;
  for (y=y0; y<ys; y+=yi) for (x=x0; x<xs; x+=xi) if (buf[y*pitch+x]==1) buf[y*pitch+x]=buf[y*pitch+x-delt]+buf[y*pitch+x+delt]>>1;  
}

void getframe2(char *buf, int pitch, Movie *m, int xs, int ys, int fno) {
  Blk **b0=m->data+((fno>>12)%m->tcnt+m->tcnt)%m->tcnt*m->ycnt*m->xcnt;
  int xk=xs/m->xcnt, yk=ys/m->ycnt, x, y;
  memset(buf, 1, ys*pitch);
  for (y=0; y<m->ycnt; y++) for (x=0; x<m->xcnt; x++)
    drawblk2(buf+y*yk*pitch+x*xk, pitch, b0[y*m->xcnt+x], xk, yk, fno&4095);
  tark(buf, pitch, xs, ys, 0, 16, 32, 32, 16*pitch);
  tark(buf, pitch, xs, ys, 16, 0, 32, 16, 16);
  tark(buf, pitch, xs, ys, 0, 8, 16, 16, 8*pitch);
  tark(buf, pitch, xs, ys, 8, 0, 16, 8, 8);
  tark(buf, pitch, xs, ys, 0, 4, 8, 8, 4*pitch);
  tark(buf, pitch, xs, ys, 4, 0, 8, 4, 4);
  tark(buf, pitch, xs, ys, 0, 2, 4, 4, 2*pitch);
  tark(buf, pitch, xs, ys, 2, 0, 4, 2, 2);
  tark(buf, pitch, xs, ys, 0, 1, 2, 2, 1*pitch);
  tark(buf, pitch, xs, ys, 1, 0, 2, 1, 1);

//  for (y=16; y<ys; y+=32) for (x=0; x<xs; x+=32) if (buf[y*pitch+x]==1) buf[y*pitch+x]=buf[(y-16)*pitch+x];  


}

int mikup(void *paskaa) {
  for (;;) MikMod_Update();
}


//3703
//#define _GNU_SOURCE
#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "signal.h"
#include <SDL/SDL.h>
#include <mikmod.h>
#include <math.h>


float con, bri;
int rando;
int stopnow=0;
float cube(float a) { return a*a*a; }

static inline float inoise(int x, int y, int z) {
  int a=x*453415497+y*692345763^z*473546769;
  int b=y*213452313+z*685246969^x*743457661;
  int c=z*915876951+x*456766761^y*421345463;
  int d=a*584278733+b*543588311^c*943566311;
  return (d>>10&65535)*(1/65536.);
}
static inline float noise(float x, float y, float z) {
  int xi=lrint(x-.5), yi=lrint(y-.5), zi=lrint(z-.5);
  float n000=inoise(xi, yi, zi);
  float n001=inoise(xi, yi, zi+1);
  float n010=inoise(xi, yi+1, zi);
  float n011=inoise(xi, yi+1, zi+1);
  float n100=inoise(xi+1, yi, zi);
  float n101=inoise(xi+1, yi, zi+1);
  float n110=inoise(xi+1, yi+1, zi);
  float n111=inoise(xi+1, yi+1, zi+1);
  float xf=x-xi, yf=y-yi, zf=z-zi, xg, yg, zg;
  xf=(3-2*xf)*xf*xf; yf=(3-2*yf)*yf*yf; zf=(3-2*zf)*zf*zf;
  xg=1-xf; yg=1-yf; zg=1-zf;
  return ((n000*zg+n001*zf)*yg+(n010*zg+n011*zf)*yf)*xg+
    ((n100*zg+n101*zf)*yg+(n110*zg+n111*zf)*yf)*xf;
}
static inline float noise2(float x, float y, float z) {
  float v=(noise(x, y, z)+noise(x+100.5, z+100.5, y+100.5))*.5;
  return (3-2*v)*v*v;
}
void line(char *b, int p, int x0, int y0, int x1, int y1, int c) {
  int x, y, xd=x1-x0, yd=y1-y0;
  int xmin=x0<x1?x0:x1, ymin=y0<y1?y0:y1, xmax=x0>x1?x0:x1, ymax=y0>y1?y0:y1;
  if (xmax-xmin>ymax-ymin) {
    for (x=xmin; x<xmax; x++) {
      y=(x-x0)*yd/xd+y0;
      b[y*p+x]=c;
    }  
  } else {
    for (y=ymin; y<ymax; y++) {
      x=(y-y0)*xd/yd+x0;
      b[y*p+x]=c;
    }  
  }  
}



#include "vox.c"
#include "demoo.c"
#include "sumu.c"



static inline void rotate2(float *u, float *v, float a) {
  float sa=sin(a), ca=cos(a), tmp=*u*ca-*v*sa;
  *v=*u*sa+*v*ca; *u=tmp;
}




typedef struct {
  float x, y, z, s;
} Dot;
Dot dots[32768];
static inline void prekalc_clouds() {
  int i;
  Dot *d;
  for (d=dots; d<dots+32768; d++) {
    do {
      d->x=(rand()-rand())*(5./RAND_MAX);
      d->y=(rand()-rand())*(5./RAND_MAX);
      d->z=(rand()-rand())*(5./RAND_MAX);
    } while (noise(d->x, d->y, d->z)>.2);
  }
}
void draw_dots() {
}



void foofoo(unsigned char *foo, int eenie, int bar, int baz, int mou) {
  if (bar>3 && baz>3) {
    int ron, jack, narf=bar>>1, zort=baz/2;
    unsigned char *dick=malloc(narf*zort);
    for (jack=0; jack<zort; jack++) {
      for (ron=0; ron<narf; ron++) dick[jack*narf+ron]=foo[jack*2*eenie+ron*2];
    }
    foofoo(dick, narf, narf, zort, mou);
    for (jack=0; jack<zort; jack++) {
      for (ron=0; ron<narf; ron++) foo[jack*2*eenie+ron*2]=dick[jack*narf+ron];
      for (ron=0; ron<narf-1; ron++) foo[jack*2*eenie+ron*2+1]=dick[jack*narf+ron]+dick[jack*narf+ron+1]>>1;
    }
    for (jack=0; jack<zort-1; jack++) {
      for (ron=0; ron<narf; ron++) foo[(jack*2+1)*eenie+ron*2]=dick[jack*narf+ron]+dick[(jack+1)*narf+ron]>>1;
      for (ron=0; ron<narf-1; ron++) foo[(jack*2+1)*eenie+ron*2+1]=(dick[jack*narf+ron]+dick[jack*narf+ron+1]+dick[(jack+1)*narf+ron]+dick[(jack+1)*narf+ron+1])*mou+foo[(jack*2+1)*eenie+ron*2+1]*4*(256-mou)+512>>10;
    }
    
  }
}

void glaah(unsigned char *foo, int eenie, int bar, int baz, int mou) {
  if (bar>3 && baz>3) {
    int ron, jack, narf=bar>>1, zort=baz/2;
    unsigned char *dick=malloc(narf*zort);
    for (jack=0; jack<zort; jack++) {
      for (ron=0; ron<narf; ron++) dick[jack*narf+ron]=foo[jack*2*eenie+ron*2];
    }
    glaah(dick, narf, narf, zort, mou);
/*    for (jack=0; jack<zort    for (jack=0; jack<zort; jack++) {
      for (ron=0; ron<narf; ron++) foo[jack*2*eenie+ron*2]=dick[jack*narf+ron];
      for (ron=0; ron<narf-1; ron++) foo[jack*2*eenie+ron*2+1]=dick[jack*narf+ron]+dick[jack*narf+ron+1]>>1;
    }
    for (jack=0; jack<zort-1; jack++) {
      for (ron=0; ron<narf; ron++) foo[(jack*2+1)*eenie+ron*2]=dick[jack*narf+ron]+dick[(jack+1)*narf+ron]>>1;
      for (ron=0; ron<narf-1; ron++) foo[(jack*2+1)*eenie+ron*2+1]=(dick[jack*narf+ron]+dick[jack*narf+ron+1]+dick[(jack+1)*narf+ron]+dick[(jack+1)*narf+ron+1])*mou+foo[(jack*2+1)*eenie+ron*2+1]*4*(256-mou)+512>>10;
    }*/
    for (jack=0; jack<baz; jack++) {
      int teheran, baghdad;
      teheran=(jack-zort)*96-(0-narf)*32+zort*128;
      baghdad=(jack-zort)*32+(0-narf)*96+narf*128;
      for (ron=0; ron<bar; ron++) {
        unsigned char *george=dick+(teheran>>8)*narf+(baghdad>>8);
        foo[jack*eenie+ron]=foo[jack*eenie+ron]*mou
           +((george[0]*(256-(teheran&255))+george[1]*(teheran&255))*(256-(baghdad&255))
           +(george[narf]*(256-(teheran&255))+foo[jack*eenie+ron]*(teheran&255))*(baghdad&255)+32768>>16)*(256-mou)+128>>8;
        teheran-=32; baghdad+=96;
      }
    }
    
  }
}






static void duunaa_sumu(char *buf, int pitch, int xs, int ys, float t) {
  short buf2[64000], *s;
  int x, y;
  char tab[1024];
  char *d;
  teesumu(buf2, t);
  for (x=0; x<1024; x++) tab[x]=sqrt(x*63.9);
  for (y=0; y<240; y++) {
    d=buf+y*pitch;
    s=buf2+y*160;
    for (x=0; x<160; x++, s++) {
      int c=*s>>4;
      if (c>1023) c=1023;
      c=tab[c]*0x0101;
      *(short*)d=c; d+=2;
    }
  }
}

void duunaa_kirkkovene(char *dbuf, char *sbuf, int pitch, int xs, int ys, float c, float b, float g, float frob, float borf) {
  unsigned static char tab[256];
  unsigned char *dp, *sp;
  int x, y, i, j;
  float f;
  for (i=0; i<256; i++) {
    f=pow((i/256.)*c+b, g);
    f=f+sin(f*frob)*borf;
    j=lrint(f*256);
    tab[i]=j<0?0:j>255?255:j;
  }
  for (y=0; y<ys; y++) {
    dp=dbuf+y*pitch;
    sp=sbuf+y*pitch;
    for (x=0; x<xs; x+=4) {
      *dp++=tab[*sp++]; *dp++=tab[*sp++]; *dp++=tab[*sp++]; *dp++=tab[*sp++];
    }
  }
}

/*#extern char musadata[];
int fakeoff=0, fakesize=56366;
int fakeseek(struct MREADER *m, long offset, int whence) { fakeoff=(whence==SEEK_SET?0:whence==SEEK_CUR?fakeoff:fakesize)+offset; return 0; }
long faketell(struct MREADER *m) { return fakeoff; }
int fakeread(struct MREADER *m, void *dest, size_t length) { memcpy(dest, musadata+fakeoff, length); fakeoff+=length; return length; }
int fakeeof(struct MREADER *m) { return fakeoff>=fakesize; }
//int fakeget(struct MREADER *m) { return fakeeof(0)?EOF:musadata[fakeoff++]; }
*/
static Tso tsot[10];
Movie *mov;

#include "desing.c"


int rajo807f(int x) { return x<-128?-128:x>127?127:x; }









int main(int argc, char *argv[]) {


  int i, j;
  float t;
  float numbs[16384];
  static char buffer[200000];
  static char U[320*240], V[320*240];
  FILE *fp;
//  OggVorbis_File oggi;
  int bufsiz;
  unsigned time0, timex;
  SDL_Surface *screen;
  SDL_Overlay *ovl;
  SDL_Color colors[256];
  static int graffa[320*200];
  int effu=argc>1?atoi(argv[1]):0;
 

//  int stopnow=0;
//  float t;
//  unsigned time0, timex;
//  SDL_Surface *screen;
//  SDL_Overlay *ovl;
  MODULE *module;
  Movie *mov;
  fp=fopen("pakked.dat", "r"); mov=readmovie(fp); fclose(fp);


  rando=time(0)>>20;

  fprintf(stderr, "d-2\n");

  fprintf(stderr, "d-1\n");

  for (i=0; i<16384; i++) numbs[i]=1+(rand()*(1./RAND_MAX));

  t=0;
  fprintf(stderr, "d4\n");



  {
    int x, y;
    float a, b, c;
    float f=rando*(2*3.141592653589793238462648336675485856345634564*1048576/3600./24./365.24)-.3;
    float k=cos(f);
    float s=cos(f+2);
    float n=.03*exp(sin(f)*sin(f)*.5);
    for (y=0; y<120; y++) for (x=0; x<160; x++) {
      a=x*.02+sin(y*.03); b=y*.02+sin(x*.03);
      
/*      ovl->pixels[1][y*320+x]=128+sin(a+b)*13+cos(a-b)*16+rand()*(4./RAND_MAX);
      ovl->pixels[2][y*320+x]=128+sin(a-b)*5+cos(a+b)*4+rand()*(4./RAND_MAX);*/
      U[y*160+x]=rajo807f((noise2(x*n, y*n, 0)-.5)*160.5+96*k);
      V[y*160+x]=rajo807f((noise2(x*n, y*n, 3)-.5)*191.5+48*s);
    }
  }
  for (j=0; j<5; j++) {
//    for (i=0; i<256; i++) tsot[j].map[i]=-1+2*cube(.5-.5*cos(((i+128&255)-128)*.2))-.2;
    for (i=0; i<256; i++) tsot[j].map[i]=-1+2*(.5-.5*cos(((i+128&255)-128)*.2))+.5*sin(((i+128&255)-128)*.05);//-.2;
  }

  for (i=0; i<256; i++) tsot[3].map[i]=sin(((i+128&255)-128)*.5)*.05;
  for (i=0; i<256; i++) tsot[4].map[i]=sin(((i+128&255)-128)*.5)*.05;

//  presumu();
  desing_precalc();
  fprintf(stderr, "d5\n");
  











  
//.  int i, j;

  printf("tot frm: %i\n", mov->tot);


  if (SDL_Init(SDL_INIT_VIDEO)<0) {
    fprintf(stderr, "sdlerror %s\n", SDL_GetError());
    return 1;
  }
  atexit(SDL_Quit);
  screen=SDL_SetVideoMode(800, 600, 16, SDL_HWSURFACE|SDL_ANYFORMAT|SDL_FULLSCREEN);
  SDL_ShowCursor(0);
  ovl=SDL_CreateYUVOverlay(640, 480, SDL_IYUV_OVERLAY, screen);

  t=0;
  SDL_EventState(SDL_KEYDOWN, SDL_ENABLE);
  SDL_EventState(SDL_QUIT, SDL_ENABLE);
 

  MikMod_RegisterAllDrivers();
  MikMod_RegisterAllLoaders();
  md_mode = DMODE_SOFT_MUSIC|DMODE_INTERP|DMODE_16BITS|DMODE_STEREO;
  if (MikMod_Init("")) {
    fprintf(stderr, "Could not initialize sound, reason: %s\n",  MikMod_strerror(MikMod_errno));
    return;
  }
  module = Player_Load("cacca.xm", 64, 0);
  if (!module) {
    fprintf(stderr, "fgsfgsrstr, reason: %s\n", MikMod_strerror(MikMod_errno));
    return;
  }
  time0=SDL_GetTicks();
  Player_Start(module);
  md_reverb=0;

    { 
      int x, y;
      unsigned char *p0, *p1, *p2;
      for (y=0; y<240; y++) {
        for (p1=ovl->pixels[1]+y*320, p2=ovl->pixels[2]+y*320, x=0; x<320; x++, p1++, p2++) {
          *p1=128; *p2=128;
        }
      }
    }

  SDL_CreateThread(mikup, 0);

  while (!stopnow) {
    static int fno=0;
    SDL_Event eve;
    SDL_Rect rectum={0,0,800,600};
    timex=SDL_GetTicks()-time0;

    while (SDL_PollEvent(&eve)) {
      if (eve.type==SDL_KEYDOWN) {
/*        if (eve.key.keysym.sym==SDLK_PLUS) Player_NextPosition();
        else if (eve.key.keysym.sym==SDLK_MINUS) Player_PrevPosition();
        else if (eve.key.keysym.sym==SDLK_KP_PLUS) Player_NextPosition();
        else if (eve.key.keysym.sym==SDLK_KP_MINUS) Player_PrevPosition(); works not with this module...
        else*/ if (eve.key.keysym.sym==SDLK_ESCAPE) stopnow++;
        else if (eve.key.keysym.sym==SDLK_q) stopnow++;
      }
      if (eve.type==SDL_QUIT) stopnow++;
    }  

/*    j=rand();
    { 
      static int kno=0;
      int x, y;
      unsigned char *d, *s=dat+kno*320*240;
      for (y=0; y<240; y++) {
        for (d=ovl->pixels[0]+y*1280, x=0; x<320; x++, d+=2, s++) {
          *d=*s; 
        }
      }
      kno=(kno+1)%klkm;
    }*/
    getframe2(ovl->pixels[0], ovl->pitches[0], mov, 640, 480, fno); fno+=300+(fno>>10);
    getframe2(ovl->pixels[1], ovl->pitches[1], mov, 320, 240, fno*(fno>96*4096?-1:1)+645);

    if (fno>32*4096)
      getframe(ovl->pixels[2], ovl->pitches[2], mov, 320, 240, fno*(fno>96*4096?-1:1)+2763);
//    design(ovl->pixels[0],ovl->pitches[0],320,240,1);
    if (fno>64*4096) {
      static int sgrol=0;
      int x, y; char *dp=ovl->pixels[0]; int pi=ovl->pitches[0];
      for (y=0; y<480; y++) for (x=0; x<640; x++) {
        if ((x&y-sgrol)==0) dp[y*pi+x]=0;
      }
      sgrol+=3;
      foofoo(ovl->pixels[0],ovl->pitches[0],640,480,192);
    }
//    if (fno>96*4096) fno+=fno-96*4096>>8;

    SDL_DisplayYUVOverlay(ovl, &rectum);
//    MikMod_Update();
//    usleep(100000);
  }

  Player_Stop();
  Player_Free(module);
  MikMod_Exit();
  return 0;
}










